<?php

class ciberprotector_Uninstaller
{

	public function uninstall()
	{
		$this->clear_wp_usermeta();
		$this->clear_wp_options();
		$this->clear_trusted_device_cookies();
	}

	private function clear_wp_usermeta()
	{
		$user_meta = array(
			'ciberprotector_totp_secret',
			'ciberprotector_totp_secret_update_date',
			'ciberprotector_totp_status',
			'ciberprotector_trusted_devices',
			'ciberprotector_step_token',
			'ciberprotector_failed_logins_count',
			'ciberprotector_user_blocked_until',
		);

		$users = get_users();

		foreach ($users as $user) {
			foreach ($user_meta as $meta_key) {
				delete_user_meta($user->ID, $meta_key);
			}
		}
	}

	private function clear_wp_options()
	{
		delete_option('ciberprotector_plugin_version');
		delete_option('ciberprotector_rate_prompt_countdown_start');
	}

	private function clear_trusted_device_cookies()
	{
		global $_COOKIE;
		$cookies = isset($_COOKIE) && is_array($_COOKIE) ? $_COOKIE : array();
		foreach (array_keys($cookies) as $cookie_name) {
			if ($this->is_cookie_for_trusted_device($cookie_name)) {
				$this->delete_cookie($cookie_name);
			}
		}
	}

	/**
	 * @param string $cookie_name
	 *
	 * @return bool
	 */
	private function is_cookie_for_trusted_device($cookie_name)
	{
		return preg_match('/^CIBERPROTECTOR_TRUSTED_DEVICE_.*/', $cookie_name) === 1;
	}

	private function delete_cookie($cookie_name)
	{
		$time = time() - 3600;
		setcookie($cookie_name, '', $time, COOKIEPATH, COOKIE_DOMAIN, false, true);
	}
}
